SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 20:09'!
blueGhost
	
	^BlueGhost new
	.! !

!PacManTest methodsFor: 'actors' stamp: 'Jamardo 5/20/2012 15:48'!
blueberry

	^BlueBerry new! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 20:14'!
down

	^Down new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
ghostHouseDoorType

	^GhostHouseDoorBlock new! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 19:34'!
left

	^Left new! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
leftTransporterType

	^LeftTransporterBlock new! !

!PacManTest methodsFor: 'actors' stamp: 'AresJamardo 5/16/2012 19:32'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 20:13'!
right

	^Right new! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
spaceType

	^SpaceBlock new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'AresJamardo 5/16/2012 20:15'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 19:34'!
up

	^Up new! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
wallType

	^WallBlock new! !

Object subclass: #Actor
	instanceVariableNames: 'currentPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'initialization' stamp: 'AresJamardo 5/16/2012 19:44'!
initialize

	currentPosition := 0@0.! !

!Actor methodsFor: 'movement' stamp: 'AresJamardo 5/16/2012 20:53'!
moveIn: aDirection to: aBlock
	
	self subclassResponsibility.! !

!Actor methodsFor: 'properties' stamp: 'AresJamardo 5/16/2012 19:35'!
position
	
	^currentPosition.! !

Actor subclass: #BlueBerry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueBerry methodsFor: 'as yet unclassified' stamp: 'Jamardo 5/20/2012 16:08'!
moveIn: aDirection to: aBlock

	^aBlock nextPositionForBlueBerry: self goingIn: aDirection.! !

Actor subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'movement' stamp: 'AresJamardo 5/16/2012 20:53'!
moveIn: aDirection to: aBlock

	^aBlock nextPositionForBlueGhost: self goingIn: aDirection.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'movement' stamp: 'AresJamardo 5/16/2012 20:53'!
moveIn: aDirection to: aBlock

	^aBlock nextPositionForPacman: self goingIn: aDirection.! !

Object subclass: #Block
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Block subclass: #ActorSensitiveBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ActorSensitiveBlock methodsFor: 'movement decision' stamp: 'AresJamardo 5/16/2012 20:53'!
nextPositionFor: anActor going: aDirection

	^anActor moveIn: aDirection to: self.! !

!ActorSensitiveBlock methodsFor: 'conditional movement decision' stamp: 'Jamardo 5/20/2012 15:51'!
nextPositionForBlueBerry: aBlueBerry goingIn:  aDirection
	self subclassResponsibility! !

!ActorSensitiveBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:47'!
nextPositionForBlueGhost: aBlueGhost goingIn:  aDirection
	self subclassResponsibility! !

!ActorSensitiveBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:47'!
nextPositionForPacman: aPacman goingIn:  aDirection
	self subclassResponsibility! !

ActorSensitiveBlock subclass: #GhostHouseDoorBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorBlock methodsFor: 'conditional movement decision' stamp: 'Jamardo 5/20/2012 16:02'!
nextPositionForBlueBerry: aBlueBerry goingIn:  aDirection

	^aDirection moveFrom: aBlueBerry position.! !

!GhostHouseDoorBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:37'!
nextPositionForBlueGhost: aBlueGhost goingIn:  aDirection

	^aDirection moveFrom: aBlueGhost position.! !

!GhostHouseDoorBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:38'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^aPacman position.! !

ActorSensitiveBlock subclass: #LeftTransporterBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterBlock methodsFor: 'conditional movement decision' stamp: 'Jamardo 5/20/2012 16:10'!
nextPositionForBlueBerry: aBlueBerry goingIn:  aDirection

	^(5@10).! !

!LeftTransporterBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:43'!
nextPositionForBlueGhost: aBlueGhost goingIn:  aDirection

	^aBlueGhost position.! !

!LeftTransporterBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:45'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^(3@10).! !

!Block methodsFor: 'movement decision' stamp: 'AresJamardo 5/16/2012 19:40'!
nextPositionFor: anActor going: aDirection

	self subclassResponsibility ! !

Block subclass: #SpaceBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceBlock methodsFor: 'movement decision' stamp: 'AresJamardo 5/16/2012 19:51'!
nextPositionFor: anActor going: aDirection

	^aDirection moveFrom: anActor position.! !

Block subclass: #WallBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallBlock methodsFor: 'movement decision' stamp: 'AresJamardo 5/16/2012 19:46'!
nextPositionFor: anActor going: aDirection

	^anActor position.! !

Object subclass: #Direction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Direction methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:52'!
moveFrom: aPosition

	self subclassResponsibility.! !

Direction subclass: #Down
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Down methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 20:16'!
moveFrom: aPosition

	^aPosition + (0@(-1)).! !

Direction subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Left methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:58'!
moveFrom: aPosition

	^aPosition + ((-1)@0).! !

Direction subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Right methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:56'!
moveFrom: aPosition

	^aPosition + (1@0).! !

Direction subclass: #Up
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Up methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:57'!
moveFrom: aPosition

	^aPosition + (0@1).! !
